import java.util.*;


public class EX2 {

/**
 * EX2: Concatenare due liste concatenate semplici (implementazioni diverse, non incluse nella classe LinkedList)
 */


  public static void concatLists(LinkedList l1, LinkedList l2){
  //Concatena l2 ad l1 lasciando l2 invariata
  if (l2.isEmpty()) return;
  ListNode pl2=l2.getHead();  //si utilizza il riferimento alla testa della lista l2
  for(; pl2!=null; pl2=pl2.getNext())
    l1.insertTail(pl2.getInfo()); //Si pu fare di meglio...

 }




/*** esercizio utile a scopo didattico per comprendere la ricorsione ***/
  public static void concatListsRec(LinkedList l1, LinkedList l2){
  //Concatena l2 ad l1 lasciando l2 invariato
  if (l2.isEmpty()) return;  // CONDIZIONE DI TERMINAZIONE
  // PASSO RICORSIVO
  Object val=l2.deleteHead(); 
  l1.insertTail(val);
  concatListsRec(l1,l2);
  l2.insertHead(val);
 }


/*** esercizio utile a scopo didattico per comprendere la ricorsione ***/
  public static void concatListsRec2(LinkedList l1, LinkedList l2){
  //Concatena l2 ad l1 lasciando l1 invariato
  if (l1.isEmpty()) return;
  concatListsRec2_aux(l1.getHead(),l2);
}

public static void concatListsRec2_aux(ListNode pl1, LinkedList l2){
  if (pl1==null) return; // CONDIZIONE DI TERMINAZIONE
  concatListsRec2_aux(pl1.getNext(),l2);
  l2.insertHead(pl1.getInfo());
}
 

  public static void main (String[ ] args) {
     new EX2().run();
  } // method main

  public void run(){

     	/**** GENERAZIONE LISTE CASUALI ****/	
     	final int SEED = 111; // seme della sequenza
     	// Random r = new Random (SEED);
     	Random r = new Random ();

     	LinkedList  randList1, randList2;
	randList1 = new LinkedList( );
	randList2 = new LinkedList( );
     	// generazione di due liste randList1 e randList2 di 10 interi casuali nel range 0...99:
     	for (int i = 0; i < 10; i++)
             randList1.insertHead (new MyInteger(r.nextInt(100)));
     	for (int i = 0; i < 10; i++){ 
             randList2.insertHead (new MyInteger(r.nextInt(100)));
	}
	System.out.println("Liste da concatenare:");
        randList1.printList( );
        randList2.printList( );

	// CONCATENAZIONE
	
	//concatLists(randList1,randList2);  //versione iterativa
        //concatListsRec(randList1,randList2); //versione ricorsiva 1
        concatListsRec2(randList1,randList2);//versione ricorsiva 2 
  
	System.out.println("Lista randList1:");
        randList1.printList( );
	System.out.println("Lista randList2:");
        randList2.printList( );
      
 } // method run

} // class EX2
